routes/web.php
<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\ArtistController;
use App\Http\Controllers\CinemaController;
use App\Http\Controllers\Controller;
use App\Http\Controllers\CountryController;
use App\Http\Controllers\MovieController;
use App\Http\Controllers\RoomController;
use App\Http\Controllers\SessionController;
use GuzzleHttp\Promise\Create;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [Controller::class, 'welcome']);

Route::get('/dashboard', function () {
  return view('dashboard');
})->middleware(['auth'])->name('dashboard');

Route::resource('artist', ArtistController::class);

Route::resource('country', CountryController::class);

Route::prefix('movie')->middleware('auth')->group(function () {
  Route::get('actors/{movie}', [MovieController::class, 'actors'])->name('movie.actors');
  Route::post('attach/{movie}', [MovieController::class, 'attach'])->name('movie.attach');
  Route::delete('detach/{movie}/{artist}', [MovieController::class, 'detach'])->name('movie.detach');
});


Route::resource('movie', MovieController::class);

Route::resource('cinema', CinemaController::class);

Route::resource('room', RoomController::class);

Route::resource('session', SessionController::class);


require __DIR__ . '/auth.php';

app/Models/Room.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Room extends Model
{
	use HasFactory;

	protected $fillable = ['places', 'cinema_id', 'user_id'];

	public function cinema()
	{
		return $this->belongsTo(Cinema::class);
	}

  public function sessions()
  {
    return $this->hasMany(Session::class);
  }
}

app/Http/Controllers/RoomController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\RoomRequest;
use App\Models\Cinema;
use App\Models\Room;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Whoops\Run;

class RoomController extends Controller
{
  /**
   * Class constructor
   */
  public function __construct()
  {
    $this->middleware('ajax')->only('destroy');
  }

  /**
   * Display a listing of the resource.
   *
   * @return \Illuminate\Http\Response
   */
  public function index()
  {
    return view('rooms.index', ['rooms' => Room::paginate(10), 'room' => Room::class]);
  }

  /**
   * Show the form for creating a new resource.
   *
   * @return \Illuminate\Http\Response
   */
  public function create()
  {
    $this->authorize('create', Room::class);

    return view('rooms.create', ['cinemas' => Cinema::all()]);
  }

  /**
   * Store a newly created resource in storage.
   *
   * @param  \Illuminate\Http\Request  $request
   * @return \Illuminate\Http\Response
   */
  public function store(RoomRequest $request)
  {
    $data = $request->all();
    $data['user_id'] = Auth::user()->id;

    Room::create($data);

    return redirect()->route('room.index')
      ->with('ok', __('Room has been saved !'));
  }

  /**
   * Display the specified resource.
   *
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function show($id)
  {
    //
  }

  /**
   * Show the form for editing the specified resource.
   *
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function edit(Room $room)
  {
    $this->authorize('update', $room);

    return view('rooms.edit', [
      'room' => $room,
    ]);
  }

  /**
   * Update the specified resource in storage.
   *
   * @param  \Illuminate\Http\Request  $request
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function update(RoomRequest $request, Room $room)
  {
    $this->authorize('update', $room);

    $room->update($request->all());

    return redirect()->route('room.index')
      ->with('ok', __('Room has been updated !'));
  }

  /**
   * Remove the specified resource from storage.
   *
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function destroy(Room $room)
  {
    $room->delete();

    return response()->json();
  }
}

resources/views/rooms/create.blade.php
<x-app>
    <x-slot name="page_title">Create a Room</x-slot>

    <form method="POST" action="{{ route('room.store') }}">
        {{ csrf_field() }}
        <p>
            <label for="places">Nb Places</label>
            <input type="text" name="places" id="places" value="" required class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
            <x-error name="places"></x-error>
        </p>
        <p>
            <label for="cinema_id">Cinema</label>
            <select name="cinema_id" id="cinema_id" required class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded">
                @foreach($cinemas as $cinema)
                <option value="{{ $cinema->id }}">
                    {{ $cinema->name }}
                </option>
                @endforeach
            </select>
            <x-error name="cinema_id"></x-error>
        </p>

        <button type="submit" class="inline-block align-middle text-center select-none border font-normal whitespace-no-wrap py-2 px-4 rounded text-base leading-normal no-underline text-blue-lightest bg-blue hover:bg-blue-light py-3 px-4 text-xl leading-tight">Create</button>
    </form>
</x-app>

resources/views/rooms/edit.blade.php
<x-app>
  <x-slot name="page_title">Edit {{ $room->cinema->name . ' ' . $room->id }}</x-slot>

  <form method="POST" action="{{ route('room.update', $room->id) }}">
    {{ csrf_field() }}
    {{ method_field('PUT') }}

    <p>
      <label for="places">Nb Places</label>
      <input type="text" name="places" id="places" value="{{ $room->places }}" required
        class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
      <x-error name="places"></x-error>
    </p>
    <p>
      <label for="cinema_id">Cinema</label>
      <select name="cinema_id" id="cinema_id" required
        class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded">
        @foreach ($cinemas as $cinema)
          <option value="{{ $cinema->id }}">
            {{ $cinema->name }}
          </option>
        @endforeach
      </select>
      <x-error name="cinema_id"></x-error>
    </p>


    <button type="submit"
      class="focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-blue-500 hover:bg-blue-600 hover:shadow-lg">
      Update
    </button>
  </form>
</x-app>

resources/views/rooms/index.blade.php
<x-app>
  <x-slot name="page_title">Rooms</x-slot>

  @can('create', $room)
    <a href="{{ route('room.create') }}"
      class="align-left focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-green-500 hover:bg-green-600 hover:shadow-lg">
      {{ __('New') }}
    </a>
  @endcan

  <table class="divide-y divide-gray-200 mt-4">
    <thead class="bg-gray-50">
      <tr>
        <th class="text-left px-2 py-3">{{ __('Cinema Room') }}</th>
        <th class="text-left px-2 py-3">{{ __('Places') }}</th>
        <th class="text-left px-2 py-3">{{ __('Actions') }}</th>
      </tr>
    </thead>
    <tbody class="bg-white text-xs divide-y divide-gray-200">
      @foreach ($rooms as $room)
        <tr>
          <td class="px-2 py-4">{{ $room->cinema->name . ' | ' . $room->id }}</td>
          <td class="px-2 py-4">{{ $room->places }}</td>
          <td class="px-2 py-4">
            @can('update', $room)
              <a href="{{ route('room.edit', $room->id) }}"
                class="focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-blue-500 hover:bg-blue-600 hover:shadow-lg">
                {{ __('Edit') }}
              </a>
            @endcan

            @can('delete', $room)
              <a href="{{ route('room.destroy', $room->id) }}"
                class="delete focus:outline-none text-white text-sm py-2.5 px-5 ml-2 rounded-md bg-red-500 hover:bg-red-600 hover:shadow-lg">
                {{ __('Delete') }}
              </a>
            @endcan
          </td>
        </tr>
      @endforeach
    </tbody>
  </table>

  {{ $rooms->links() }}

  <script>
    // Récupération du token
    let token = document.querySelector('meta[name="csrf-token"]').getAttribute('content');

    // Ajout des événements
    document.querySelectorAll('.delete').forEach(item => {
      item.addEventListener('click', event => {
        event.preventDefault();

        // Requête AJAX de suppression
        fetch(event.target.href, {
            headers: {
              'X-Requested-With': 'XMLHttpRequest',
              'X-CSRF-TOKEN': token
            },
            method: 'DELETE',
          })
          .then((data) => {
            event.target.closest('tr').remove();
          });
      })
    });

  </script>

</x-app>